#include <math.h>
#include "kr3obu.h"
#include "sini.h"

#define schar signed char

#define MAXVERTIXES 100
#define MAXFACES 100

typedef
struct {    schar x,y,z;
            schar cx,cy,cz;
            char calcd;
            } vertex;

typedef
struct {    char v1,v2,v3,txt;
	    schar nx,ny,nz;
            } face;

typedef
struct {    int vxnum,fcnum;
	    vertex vx[MAXVERTIXES];
            vertex vxr[MAXVERTIXES]; /* rotated'n'kalkdhd */
            face fc[MAXFACES];
            } obu;

obu mohkale;



unsigned char bufu[30][80];
unsigned char *cruutu = (unsigned char *) 0xb8000000;



/********************* 3D OBJECT L0ADER ***********************/

signed int sqr(signed char hum)
{
	return hum*hum;
}

char sgn(signed int hm)
{
      char o=0;
      if (hm<0) o=1;
      if (hm>0) o=2;
      return o;
}

calcnmals(obu o, face f)
{

      signed int
          ox,oy,oz,
          ax,ay,az,
	  bx,by,bz;
      signed long int nx,ny,nz;
      double nl;

                  /* LASKETAAN NORMAALIT */

            ox=o.vx[f.v1].x;         /* origo */
            oy=o.vx[f.v1].y;
            oz=o.vx[f.v1].z;

            ax=o.vx[f.v2].x - ox;    /* origo -> v2 */
            ay=o.vx[f.v2].y - oy;
            az=o.vx[f.v2].z - oz;

            bx=o.vx[f.v3].x - ox;    /* origo -> v3 */
            by=o.vx[f.v3].y - oy;
            bz=o.vx[f.v3].z - oz;

            nx = ay*bz - az*by;                /* ristitulo */
            ny = ax*bz - az*bx;
            nz = ax*by - ay*bx;

            nl=(nx*nx)+(ny*ny)+(nz*nz);         /* 127:n pituisiksi. */
            nl=sqrt(nl/16256.0);

            f.nx=(signed char)(nx/nl);  /* ja talteen */
            f.ny=(signed char)(ny/nl);
            f.nz=(signed char)(nz/nl);

}

loadobj(obu o, char *raw)
{
      char i;

      o.fcnum = *raw++;
      o.vxnum = *raw++;		cprintf("%i vertixes %i faces",o.vxnum,o.fcnum);

      for(i=0;i<o.vxnum;i++)    {       /* VURTEKSIT */
	    o.vx[i].x=*raw++;
	    o.vx[i].y=*raw++;
	    o.vx[i].z=*raw++; }

      for(i=0;i<o.fcnum;i++)   {        /* FEIZZIT */
	    o.fc[i].v1=*raw++;
	    o.fc[i].v2=*raw++;
	    o.fc[i].v3=*raw++;
	    o.fc[i].txt=*raw++;

	    calcnmals(o,o.fc[i]);

      }
}

/****************************************************************/

pyorayta3(obu o, char k1, char k2, char k3, char xpos, char ypos,char zoom)
{
      schar c0,c1,c2, s0,s1,s2,
            x0,y0,z0, x1,y1,z1, x2,y2,z2;
      int i;

      c0=sini[(k1+64)&255];s0=sini[k1&255];
      c1=sini[(k2+64)&255];s1=sini[k2&255];
      c2=sini[(k3+64)&255];s2=sini[k3&255];

      for(i=0;i<o.vxnum;i++)
      {
            x0=o.vx[i].x;
            y0=o.vx[i].y;
            z0=o.vx[i].z;

            x1 = (c0*x0 + s0*y0) >> 7;
            y1 = (c0*y0 - s0*x0) >> 7;

            x2 = (c1*x1 + s1*z0) >> 7;
            z1 = (c1*z0 + s1*x1) >> 7;

            y2 = (c2*y1 + s2*z1) >> 7;
            z2 = (c2*z1 - s2*y1) >> 7;

            if (zoom){
                  x2=(x2*zoom)>>6;
                  y2=(y2*zoom)>>6; }

            o.vxr[i].x = (x2>>2) + xpos;
            o.vxr[i].y = (y2>>2) + ypos;
            o.vxr[i].z = z2;
      }
}

qcomp(signed int *i,signed int *j)
{return *i-*j;}

piirra3(obu o)
{
      signed int fcs[2*MAXFACES],*s;
      int i;

      s=fcs;

      for(i=0;i<o.fcnum;i++) {
            *s++=o.vx[o.fc[i].v1].z   /* lis backfacecullingcheck */
                +o.vx[o.fc[i].v2].z
                +o.vx[o.fc[i].v3].z;
            *s++=i;
      }

      qsort(fcs,o.fcnum,4,qcomp);

      for(i=0;i<o.fcnum;i++) {
	    cprintf("joo ");
	    drawface(o,o.fc[ 1+fcs[2*i] ] );
      }
}


/*************************************************************

                iNTo dA cORE: gouraud shading

*************************************************************/

signed int x0,y0,c0,dx0,dy0,dc0,
	   x1,y1,c1,dx1,dy1,dc1;

char pal[3][16] =

      {0x00,0x00,0x00,0x01,   /* punainen */
       0x04,0x40,0x44,0x45,
       0x4c,0xc4,0xcc,0xce,
       0xec,0xee,0xee,0xee,

       0x00,0x00,0x00,0x01,   /* vihre */
       0x02,0x02,0x20,0x20,
       0x22,0x22,0x2a,0x2a,
       0xa2,0xa2,0xaa,0xab,

       0x00,0x00,0x00,0x01,   /* sininen */
       0x01,0x10,0x11,0x13,
       0x19,0x91,0x99,0x9b,
       0xb9,0xbb,0xbf,0xfb };

clearbuffer()
{
      char x,y,*s;
      s=bufu[0];
      for(y=0;y<25;y++)
      for(x=0;x<80;x++) *s++=0;
}

dumpbuffer()
{
      char x,y,*s,*t;
      s=bufu[0];t=cruutu;
      gotoxy(1,1);
      for(y=0;y<25;y++)
      for(x=0;x<80;x++) *(t+=2)=*s++;
}

gouraudrow(char y,char x0,char x1,char c0,char c1,char txr,int cs)
{
      char t,x;
      int cin;

      cprintf("hii");

      if (x1<x0) { t=x1;x1=x0;x0=t;
                   t=c1;c1=c0;c0=t;}

      cin=c0<<8;

      for(x=x0;x<x1;x++)
      {
	    if (x>=0) if (x<=80) if (y>=0) if (y<=25)
	       bufu[y][x]=txr*0x11;
	       /*pal[txr][cin>>8];*/
	    cin+=cs;
      }
}

puolikolmio(schar y,schar yl, char palno, int cstep)
{
      char c,x;
      char *palli;

      for(;y<yl;y++) {

            x0+=dx0;  x1+=dx1;
            c0+=dc0;  c1+=dc1;      /* h, eihn c1/dc1:t edes tarvita */

	    gouraudrow(y,x0,x1,c0,c1,palno,cstep);

/*          if (outti>=ruutu) {
              if (x1>x0)   GRD_ROW(outti,palli,x0,x1,c0,cstep);
                      else GRD_ROW(outti,palli,x1,x0,c1,cstep); }

            outti+=80; */

}       }


drawface(obu o,face f)
{
      schar KX0=o.vx[f.v1].x,
            KY0=o.vx[f.v1].y,
            KC0=o.vx[f.v1].z,       /* zgouraud */

            KX1=o.vx[f.v2].x,
            KY1=o.vx[f.v2].y,
            KC1=o.vx[f.v2].z,

            KX2=o.vx[f.v3].x,
	    KY2=o.vx[f.v3].y,
            KC2=o.vx[f.v3].z,

            palno=f.txt;

      int cstep;

      cprintf("hmm..");

      KC1>>=2;KC2>>=2;

      if (KC0<0) KC0=0;       /* vrirajat */
      if (KC1<0) KC1=0;
      if (KC2<0) KC2=0;

      if (KC0>15) KC0=15;
      if (KC1>15) KC1=15;
      if (KC2>15) KC2=15;

      if ((KY0==KY1) && (KY1==KY2)) {}    /* ei vaakaviivoja */
      else{

            x0=KX0<<8;x1=KX0<<8;
            c0=KC0<<8;c1=KC1<<8; /*gouraud*/

      if (KY0!=KY1) {   /* piikkihuippu */

            dx0=((KX1-KX0)<<8)/(KY1-KY0);
            dx1=((KX2-KX0)<<8)/(KY2-KY0);

            /* gouraud */
               dc0=((KC1-KC0)<<8)/(KY1-KY0);
               dc1=((KC2-KC0)<<8)/(KY2-KY0);

            cstep=DIV32(dc1-dc0,dx1-dx0);

	    puolikolmio(KY0,KY1,palno,cstep);

      } else {          /* tasahuippu */

            dx1=((KX2-KX1)<<8)/(KY2-KY0);

            /* gouraud */
               dc1=((KC2-KC1)<<8)/(KY2-KY0);

            cstep=DIV32(c1-c0,x1-x0);

            }

      if (KY1!=KY2) {   /* piikkipohja */

            dx0=((KX2<<8)-x0)/(KY2-KY1);

            /* gouraud */
               dc0=((KC2<<8)-c0)/(KY2-KY1);

	    puolikolmio(KY1,KY2,palno,cstep);

            }
      }
}

main()
{
      char r1=0,r2=12,r3=77;

      printf("loading object data");
      loadobj(mohkale,obu_rpali);

      getch();

      while(!kbhit()){

      clearbuffer();
      pyorayta3(mohkale,r1++,r2++,r3++,40,12,0);
      piirra3(mohkale);
      dumpbuffer();

      }
}

/*
      ruttiineita.

      yleinen bufferiformaatti.

      typedef struct {
            char xsize,ysize,*data } scrbuf;

      scrbuf_init(bufukka,TM25);

      scrbuf_clear(bufukka);

      scrbuf_dump(bufukka)


      pyryttelijit yleistetn.

                                 req'd data

                              poly  face  vtex
                              xy    nmals nmals

      back-face culling             X

            flat shading

      flat shading            X
      flat shading w/ light   X     X

            interpolated 1 value

      depth shading           X
      gouraud shading         X           X

            interpolated vectors

      texture mapping         X                       (xy)
      environment mapping     X           X           (xy)
      phong shading           X           X           (xyz)

*/

